// XML.h: helper class.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "../TaskProcessor.h"
#include "../Other/XMLhelper.h"

class CXmlTask : public CTask
{
public:
	CXmlTask();
	virtual bool LoadParams(XmlElement spElem) = 0;
	virtual CString PrepareResult();

public:
	ULONG	m_ulId;
};

// Defining Xml task classes
#define BEGIN_XML_CMD(name)		class CXml_##name : public CXmlTask { public: \
									bool Process(CEmEngine &);\
									bool LoadParams(XmlElement spElem);
#define XML_PARAM_STRING(var)		CString m_s##var;
#define XML_PARAM_ULONG(var)		ULONG m_ul##var;
#define END_XML_CMD				};
#include "XMLMsgs.h"

#define XML_PROCESS_FUNC(name)	bool CXml_##name::Process(CEmEngine &stEngine)
