//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "ircsocket.h"
#include "Loggable.h"

class CIrcWnd;
class CIrcMain : public CLoggable
{
public:
	CIrcMain(void);
	~CIrcMain(void);
	void ParseMessage(CString strRawMessage);
	void PreParseMessage(CString strBuffer);
	void SendLogin();
	void Connect();
	void Disconnect(bool bIsShuttingDown = false);
	void SetConnectStatus(bool bConnected);
	void SetIRCWnd(CIrcWnd* pWndIRC)	{m_pWndIRC = pWndIRC;}
	int SendString(CString strSend);
	void ParsePerform();
	//void ProcessLink(const CString& ed2kLink );
	uint32 SetVerify()					{iVerify = rand();
						            	return iVerify;}

	CString GetNick()	{return strNick;}
private:
	CIrcSocket	*m_pIrcSocket;
	CIrcWnd		*m_pWndIRC;
	CString		strPreParseBuffer;
	CString		strUser;
	CString		strNick;
	CString		strVersion;
	uint32		iVerify;
};
