//--- xrmb:downloadclientslist ---
//--- xrmb:parttraffic ---
#include "StdAfx.h"
#include "listControlSorter.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//-------------------------------------------------------------------------------------------------
CListCtrlSorter::CListCtrlSorter() 
:	m_selected(0),
	m_itemc(0),
	m_items(NULL)
{
}

//-------------------------------------------------------------------------------------------------
void CListCtrlSorter::init(byte items)
{
	m_itemc=items;
	m_items=new CListCtrlSorterItem*[m_itemc];
	for(byte i=0; i<m_itemc; i++)
		m_items[i]=new CListCtrlSorterItem(i);
}

//-------------------------------------------------------------------------------------------------
CListCtrlSorter::~CListCtrlSorter() 
{
	if(m_items)
	{
		for(byte i=0; i<m_itemc; i++)
			delete m_items[i];

		delete[] m_items;
		m_items=NULL;
	}
}

//-------------------------------------------------------------------------------------------------
void CListCtrlSorterItem::set(byte levels, bool reverse, bool defaultDir, byte defaultLevel)
{
	m_level=defaultLevel;
	m_dir=defaultDir;
	m_reverse=reverse;

	m_levels=levels;
	m_defaultDir=defaultDir;
	m_defaultLevel=defaultLevel;
}

//Cax2 I needed a REAL set function...
void CListCtrlSorterItem::sortIt(byte level, bool dir){
	m_level=level;
	m_dir=(dir ^ m_reverse);
}


//-------------------------------------------------------------------------------------------------
void CListCtrlSorterItem::clicked(byte id)
{
	if(m_id!=id)
	{
		m_dir=m_defaultDir;
		m_level=m_defaultLevel;
	}
	else
	{
		m_dir=!m_dir;
		if(m_dir)
		{
			m_level%=m_levels;
			m_level++;		
		}
	}
}

//-------------------------------------------------------------------------------------------------
CMuleListCtrl::ArrowType CListCtrlSorterItem::arrow()
{
	if(m_level==1)
	{
		if(m_dir ^ m_reverse)
			return CMuleListCtrl::ArrowType::arrowUp;
		else
			return CMuleListCtrl::ArrowType::arrowDown;
	}
	else
	{
		if(m_dir ^ m_reverse)
			return CMuleListCtrl::ArrowType::arrowDoubleUp;
		else
			return CMuleListCtrl::ArrowType::arrowDoubleDown;
	}
}