//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "PPgNotify.h"
#include "AddBuddy.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CPPgNotify, CPropertyPage)
CPPgNotify::CPPgNotify()
	: CPropertyPage(CPPgNotify::IDD)
	, useSound(FALSE)
	, onLog(FALSE)
	, onChat(FALSE)
	, onChatMessage(FALSE)
	, onDownloadAdded(FALSE)
	, onDownloadFinished(FALSE)
	, useScheduler(FALSE)
	, onWebServer(FALSE)
	, onImportant(FALSE)
	, onServerError(FALSE)
	, wavFileName(_T(""))
	, warningDesc(_T(""))
	, optionsDesc(_T(""))
	, propertiesDesc(_T(""))
	, displayTimeDesc(_T(""))
	, fontSizeDesc(_T(""))
	, secDesc(_T(""))
{
	LoadSettings();
	Localize();
}

CPPgNotify::~CPPgNotify()
{
}

void CPPgNotify::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CB_TBN_USESOUND, useSound);
	DDX_Check(pDX, IDC_CB_TBN_ONLOG, onLog);
	DDX_Check(pDX, IDC_CB_TBN_ONCHAT, onChat);
	DDX_Check(pDX, IDC_CB_TBN_POP_ALWAYS, onChatMessage);
	DDX_Check(pDX, IDC_CB_TBN_ONDOWNLOADADD, onDownloadAdded);
	DDX_Check(pDX, IDC_CB_TBN_ONDOWNLOAD, onDownloadFinished);
	DDX_Check(pDX, IDC_CB_TBN_USESCHEDULER, useScheduler);
	DDX_Check(pDX, IDC_CB_TBN_WEBSERVER, onWebServer);
	DDX_Check(pDX, IDC_CB_TBN_IMPORTANT, onImportant);
	DDX_Check(pDX, IDC_CB_TBN_SERVER, onServerError);
	DDX_Text(pDX, IDC_EDIT_TBN_WAVFILE, wavFileName);	
	DDX_Control(pDX, IDC_COMBO_TBN_DTIME, dtimeCombo);
	DDX_Control(pDX, IDC_COMBO_TBN_FSIZE, fsizeCombo);
	DDX_Control(pDX, IDC_CB_TBN_USESOUND, useSoundCheck);
	DDX_Control(pDX, IDC_CB_TBN_ONLOG, onLogCheck);
	DDX_Control(pDX, IDC_CB_TBN_ONCHAT, onChatCheck);
	DDX_Control(pDX, IDC_CB_TBN_POP_ALWAYS, onChatMessageCheck);
	DDX_Control(pDX, IDC_CB_TBN_ONDOWNLOADADD, onDownloadAddedCheck);
	DDX_Control(pDX, IDC_CB_TBN_ONDOWNLOAD, onDownloadFinishedCheck);
	DDX_Control(pDX, IDC_CB_TBN_USESCHEDULER, useSchedulerCheck);
	DDX_Control(pDX, IDC_CB_TBN_WEBSERVER, onWebServerCheck);
	DDX_Control(pDX, IDC_CB_TBN_IMPORTANT, onImportantCheck);
	DDX_Control(pDX, IDC_CB_TBN_SERVER, onServerErrorCheck);
	DDX_Text(pDX, IDC_TBN_WARNING, warningDesc);
	DDX_Text(pDX, IDC_TBN_OPTIONS, optionsDesc);
	DDX_Text(pDX, IDC_TBN_PROPERTIES, propertiesDesc);
	DDX_Text(pDX, IDC_CB_TBN_DTIME, displayTimeDesc);
	DDX_Text(pDX, IDC_CB_TBN_FSIZE, fontSizeDesc);
	DDX_Text(pDX, IDC_CB_TBN_SEC, secDesc);
	DDX_Control(pDX, IDC_EDIT_TBN_WAVFILE, wavFileNameEdit);
	DDX_Control(pDX, IDC_BTN_BROWSE_WAV, wavFileNameButton);
}

BEGIN_MESSAGE_MAP(CPPgNotify, CPropertyPage)
	ON_BN_CLICKED(IDC_CB_TBN_USESOUND, OnBnClickedCbTbnUsesound)
	ON_BN_CLICKED(IDC_CB_TBN_ONLOG, OnBnClickedCbTbnOnlog)
	ON_BN_CLICKED(IDC_CB_TBN_ONCHAT, OnBnClickedCbTbnOnchat)
	ON_BN_CLICKED(IDC_CB_TBN_POP_ALWAYS, OnBnClickedCbTbnPopAlways)
	ON_BN_CLICKED(IDC_CB_TBN_ONDOWNLOADADD, OnBnClickedCbTbnOndownloadAdd)
	ON_BN_CLICKED(IDC_CB_TBN_ONDOWNLOAD, OnBnClickedCbTbnOndownload)
	ON_BN_CLICKED(IDC_CB_TBN_IMPORTANT, OnBnClickedCbTbnImportant)
	ON_BN_CLICKED(IDC_CB_TBN_WEBSERVER, OnBnClickedCbTbnWebServer)
	ON_BN_CLICKED(IDC_CB_TBN_SERVER, OnBnClickedCbTbnServer)
	ON_BN_CLICKED(IDC_CB_TBN_USESCHEDULER, OnBnClickedCbTbnUseScheduler)
	ON_BN_CLICKED(IDC_BTN_BROWSE_WAV, OnBnClickedBtnBrowseWav)
	ON_CBN_SELCHANGE(IDC_COMBO_TBN_DTIME, OnCbnSelchangeDtime)
	ON_CBN_SELCHANGE(IDC_COMBO_TBN_FSIZE, OnCbnSelchangeFsize)
	ON_EN_CHANGE(IDC_EDIT_TBN_WAVFILE, OnEnChangeEditTbnWavfile)
END_MESSAGE_MAP()

BOOL CPPgNotify::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("1")),1000);
	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("2")),2000);
	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("3")),3000);
	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("4")),4000);
	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("5")),5000);
	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("6")),6000);
	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("7")),7000);
	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("8")),8000);
	dtimeCombo.SetItemData(dtimeCombo.AddString(_T("9")),9000);

	fsizeCombo.SetItemData(fsizeCombo.AddString(_T("7")),70);
	fsizeCombo.SetItemData(fsizeCombo.AddString(_T("8")),80);
	fsizeCombo.SetItemData(fsizeCombo.AddString(_T("9")),90);
	fsizeCombo.SetItemData(fsizeCombo.AddString(_T("10")),100);

	AddBuddy(wavFileNameEdit.m_hWnd, wavFileNameButton.m_hWnd, BDS_RIGHT);

	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgNotify::LoadSettings(void)
{
	if(::IsWindow(m_hWnd))
	{
		onDownloadAdded = m_pPrefs->GetUseDownloadAddNotifier();
		onDownloadFinished = m_pPrefs->GetUseDownloadNotifier();		
		onChat = m_pPrefs->GetUseChatNotifier();
		useSound = m_pPrefs->GetUseSoundInNotifier();
		onLog = m_pPrefs->GetUseLogNotifier();
		useScheduler = m_pPrefs->GetUseSchedulerNotifier();
		onChatMessage = m_pPrefs->GetNotifierPopsEveryChatMsg();
		onImportant = m_pPrefs->GetNotifierPopOnImportantError();
		onWebServer = m_pPrefs->GetNotifierPopOnWebServerError();
		onServerError = m_pPrefs->GetNotifierPopOnServerError();
		wavFileName = m_pPrefs->GetNotifierWavSoundPath();
				
		onChatMessageCheck.EnableWindow(onChat);

		for(int i = 0; i != dtimeCombo.GetCount(); i++)
			if(dtimeCombo.GetItemData(i) == m_pPrefs->NotificationDisplayTime())
				dtimeCombo.SetCurSel(i);

		for(int i = 0; i != fsizeCombo.GetCount(); i++)
			if(fsizeCombo.GetItemData(i) == m_pPrefs->NotificationFontSize())
				fsizeCombo.SetCurSel(i);

		UpdateData(FALSE);

		OnBnClickedCbTbnUsesound();
	}

	SetModified(FALSE);
}

BOOL CPPgNotify::OnApply() 
{
    if(m_bModified)
	{
		UpdateData(TRUE);
	    
		m_pPrefs->SetUseDownloadAddNotifier(onDownloadAdded);
		m_pPrefs->SetUseDownloadNotifier(onDownloadFinished);
	   	m_pPrefs->SetUseChatNotifier(onChat);
    	m_pPrefs->SetUseLogNotifier(onLog);        
    	m_pPrefs->SetUseSoundInNotifier(useSound);
    	m_pPrefs->SetUseSchedulerNotifier(useScheduler);
    	m_pPrefs->SetNotifierPopsEveryChatMsg(onChatMessage);
		m_pPrefs->SetNotifierPopOnImportantError(onImportant);
		m_pPrefs->SetNotifierPopOnWebServerError(onWebServer);
		m_pPrefs->SetNotifierPopOnServerError(onServerError);    	
		m_pPrefs->SetNotifierWavSoundPath(wavFileName);
	
		if (dtimeCombo.GetCurSel() != CB_ERR)
		{
			m_pPrefs->SetNotificationDisplayTime(dtimeCombo.GetItemData(dtimeCombo.GetCurSel()));
		}
		if (fsizeCombo.GetCurSel() != CB_ERR)
		{
			m_pPrefs->SetNotificationFontSize(fsizeCombo.GetItemData(fsizeCombo.GetCurSel()));
		}
	
		((CEmuleDlg*)AfxGetMainWnd())->m_wndTaskbarNotifier.SetTextFont(_T("Arial"),g_eMuleApp.m_pGlobPrefs->NotificationFontSize(),TN_TEXT_NORMAL,TN_TEXT_UNDERLINE); // Popup porperties [DonGato]
	
		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgNotify::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_EKDEV_OPTIONS));

		useSoundCheck.SetWindowText(GetResString(IDS_PW_TBN_USESOUND));
		onLogCheck.SetWindowText(GetResString(IDS_PW_TBN_ONLOG));
		onChatCheck.SetWindowText(GetResString(IDS_PW_TBN_ONCHAT));
		onChatMessageCheck.SetWindowText(GetResString(IDS_PW_TBN_POP_ALWAYS));
		onDownloadAddedCheck.SetWindowText(GetResString(IDS_PW_TBN_ONDOWNLOADADD));
		onDownloadFinishedCheck.SetWindowText(GetResString(IDS_PW_TBN_ONDOWNLOAD));
		onImportantCheck.SetWindowText(GetResString(IDS_PS_TBN_IMPORTANT));
		onWebServerCheck.SetWindowText(GetResString(IDS_PS_TBN_WEBSERVER));
		onServerErrorCheck.SetWindowText(GetResString(IDS_PS_TBN_SERVER));
		useSchedulerCheck.SetWindowText(GetResString(IDS_PW_TBN_USESCHEDULER));		
		GetResString(&warningDesc, IDS_PW_TBN_WARNING);
		GetResString(&optionsDesc, IDS_PW_TBN_OPTIONS);
		GetResString(&propertiesDesc, IDS_TBN_PROPERTIES);
		GetResString(&displayTimeDesc, IDS_CB_TBN_DTIME);
		GetResString(&fontSizeDesc, IDS_CB_TBN_FSIZE);
		GetResString(&secDesc, IDS_SECS);

		UpdateData(FALSE);
	}
}

void CPPgNotify::OnBnClickedCbTbnOnchat()
{
    UpdateData(TRUE);
    onChatMessageCheck.EnableWindow(onChat);	

	SetModified();
}

void CPPgNotify::OnBnClickedBtnBrowseWav()
{
    if (DialogBrowseFile(wavFileName, _T("Audio-Wav (*.wav)|*.wav||")))
	{
		m_pPrefs->SetNotifierWavSoundPath(wavFileName);
		UpdateData(FALSE);

		SetModified();
	}
}

void CPPgNotify::OnBnClickedCbTbnUsesound()
{
	UpdateData(TRUE);
	wavFileNameEdit.EnableWindow(useSound);
	wavFileNameButton.EnableWindow(useSound);

	SetModified();
}
